/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.23 Revision 1.38
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.23 2006/03/09 12:37:01 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.38 2006/10/20 13:14:21 chtekk Exp $
4 4
5# Author: Francesco Riosa <vivo at gentoo.org> 5# Author: Francesco Riosa <vivo@gentoo.org>
6# Maintainer: Francesco Riosa <vivo at gentoo.org> 6# Maintainer: Luca Longinotti <chtekk@gentoo.org>
7
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too
9# Note that MYSQL_VERSION_ID must be empty !!!
10
11# MYSQL_VERSION_ID will be:
12# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
13# This is an important part, because many of the choices the MySQL ebuild will do
14# depend on this variable.
15# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
16
17if [[ -z "${MYSQL_VERSION_ID}" ]] ; then
18 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
19 for vatom in 0 1 2 3 ; do
20 # pad to length 2
21 tpv[${vatom}]="00${tpv[${vatom}]}"
22 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
23 done
24 # strip leading "0" (otherwise it's considered an octal number by BASH)
25 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
26fi
27
28DEPEND="${DEPEND}
29 >=sys-libs/readline-4.1
30 berkdb? ( sys-apps/ed )
31 ssl? ( >=dev-libs/openssl-0.9.6d )
32 userland_GNU? ( sys-process/procps )
33 >=sys-libs/zlib-1.2.3
34 >=sys-apps/texinfo-4.7-r1
35 >=sys-apps/sed-4"
36
37RDEPEND="${DEPEND} selinux? ( sec-policy/selinux-mysql )"
38
39# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
40PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
7 41
8inherit eutils flag-o-matic gnuconfig autotools mysql_fx 42inherit eutils flag-o-matic gnuconfig autotools mysql_fx
9 43
10#major, minor only in the slot
11SLOT=$(( ${MYSQL_VERSION_ID} / 10000 ))
12
13# shorten the path because the socket path length must be shorter than 107 chars 44# Shorten the path because the socket path length must be shorter than 107 chars
14# and we will run a mysql server during test phase 45# and we will run a mysql server during test phase
15S="${WORKDIR}/${PN}" 46S="${WORKDIR}/${PN}"
16 47
48# Define $MY_FIXED_PV for MySQL patchsets
49MY_FIXED_PV="${PV/_alpha/}"
50#MY_FIXED_PV="${MY_FIXED_PV/_beta/}"
51#MY_FIXED_PV="${MY_FIXED_PV/_rc/}"
52
53# Define correct SRC_URIs
54SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${P/_/-}${MYSQL_RERELEASE}.tar.gz"
55if [[ -n "${MYSQL_PATCHSET_REV}" ]] ; then
56 MYSQL_PATCHSET_FILENAME="${PN}-patchset-${MY_FIXED_PV}-r${MYSQL_PATCHSET_REV}.tar.bz2"
57 # We add the Gentoo mirror here, as we only use primaryuri for the MySQL tarball
58 SRC_URI="${SRC_URI} http://gentoo.longitekk.com/${MYSQL_PATCHSET_FILENAME}"
59fi
60
17DESCRIPTION="A fast, multi-threaded, multi-user SQL database server" 61DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
18HOMEPAGE="http://www.mysql.com/" 62HOMEPAGE="http://www.mysql.com/"
19NEWP="${P/_/-}" 63SLOT="0"
20SRC_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/${NEWP}.tar.gz
21 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
22LICENSE="GPL-2" 64LICENSE="GPL-2"
23IUSE="big-tables berkdb debug embedded minimal perl selinux srvdir ssl static" 65IUSE="big-tables berkdb debug embedded minimal perl selinux srvdir ssl static"
24RESTRICT="primaryuri confcache" 66RESTRICT="confcache"
67
68mysql_version_is_at_least "4.01.00.00" \
69&& IUSE="${IUSE} latin1"
25 70
26mysql_version_is_at_least "4.01.03.00" \ 71mysql_version_is_at_least "4.01.03.00" \
27&& IUSE="${IUSE} cluster extraengine" 72&& IUSE="${IUSE} cluster extraengine"
28 73
29mysql_version_is_at_least "5.00.00.00" \ 74mysql_version_is_at_least "5.00.00.00" \
33&& IUSE="${IUSE} max-idx-128" 78&& IUSE="${IUSE} max-idx-128"
34 79
35mysql_version_is_at_least "5.01.00.00" \ 80mysql_version_is_at_least "5.01.00.00" \
36&& IUSE="${IUSE} innodb" 81&& IUSE="${IUSE} innodb"
37 82
38EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_config pkg_prerm pkg_postrm 83EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
84 pkg_postinst pkg_config pkg_postrm
85
86#
87# HELPER FUNCTIONS:
88#
39 89
40# void mysql_init_vars() 90# void mysql_init_vars()
41# 91#
42# initialize global variables 92# Initialize global variables
43# 2005-11-19 <vivo at gentoo.org> 93# 2005-11-19 <vivo@gentoo.org>
94
44mysql_init_vars() { 95mysql_init_vars() {
45
46 if [[ ${SLOT} -eq 0 ]] ; then
47 MY_SUFFIX=""
48 else
49 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
50 fi
51 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 96 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
52 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 97 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
53 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 98 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
54 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 99 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
55 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 100 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
56 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 101 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
57 102
58 if [ -z "${DATADIR}" ]; then 103 if [[ -z "${DATADIR}" ]] ; then
59 DATADIR="" 104 DATADIR=""
60 if [ -f "${MY_SYSCONFDIR}/my.cnf" ] ; then 105 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
61 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null | sed -ne '/datadir/s|^--datadir=||p' | tail -n1` 106 DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
107 | sed -ne '/datadir/s|^--datadir=||p' \
108 | tail -n1`
62 if [ -z "${DATADIR}" ]; then 109 if [[ -z "${DATADIR}" ]] ; then
63 if useq "srvdir" ; then 110 if useq "srvdir" ; then
64 DATADIR="${ROOT}/srv/localhost/mysql${MY_SUFFIX}/datadir" 111 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
65 else 112 else
66 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" | sed -e 's/.*=\s*//'` 113 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
114 | sed -e 's/.*=\s*//'`
67 fi 115 fi
68 fi 116 fi
69 fi 117 fi
70 if [ -z "${DATADIR}" ]; then 118 if [[ -z "${DATADIR}" ]] ; then
71 if useq "srvdir" ; then 119 if useq "srvdir" ; then
72 DATADIR="${ROOT}/srv/localhost/mysql${MY_SUFFIX}/datadir" 120 DATADIR="${ROOT}/srv/localhost/mysql/datadir"
73 else 121 else
74 DATADIR="${MY_LOCALSTATEDIR}" 122 DATADIR="${MY_LOCALSTATEDIR}"
75 fi 123 fi
76 einfo "Using default DATADIR" 124 einfo "Using default DATADIR"
77 fi 125 fi
78 einfo "MySQL DATADIR is ${DATADIR}" 126 einfo "MySQL DATADIR is ${DATADIR}"
79 127
80 if [ -z "${PREVIOUS_DATADIR}" ] ; then 128 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
81 if [ -a "${DATADIR}" ] ; then 129 if [[ -e "${DATADIR}" ]] ; then
82 ewarn "Previous datadir found, it's YOUR job to change" 130 ewarn "Previous datadir found, it's YOUR job to change"
83 ewarn "ownership and have care of it" 131 ewarn "ownership and take care of it"
84 PREVIOUS_DATADIR="yes" 132 PREVIOUS_DATADIR="yes"
85 export PREVIOUS_DATADIR
86 else 133 else
87 PREVIOUS_DATADIR="no" 134 PREVIOUS_DATADIR="no"
88 export PREVIOUS_DATADIR
89 fi 135 fi
90 fi 136 export PREVIOUS_DATADIR
91 fi 137 fi
138 fi
92 139
93 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 140 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
94 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 141 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
95 export MY_INCLUDEDIR 142 export MY_INCLUDEDIR
96 export DATADIR 143 export DATADIR
97} 144}
98 145
146configure_minimal() {
147 # these are things we exclude from a minimal build
148 # note that the server actually does get built and installed
149 # but we then delete it before packaging.
150 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication"
151
152 for i in ${minimal_exclude_list}; do
153 myconf="${myconf} --without-${i}"
154 done
155 myconf="${myconf} --with-extra-charsets=none"
156}
157
158configure_common() {
159 myconf="${myconf} --enable-local-infile"
160 myconf="${myconf} --with-extra-charsets=all"
161 myconf="${myconf} --with-mysqld-user=mysql"
162 myconf="${myconf} --with-unix-socket-path='/var/run/mysqld/mysqld.sock'"
163 myconf="${myconf} --without-libwrap"
164
165 if useq "static" ; then
166 myconf="${myconf} --with-mysqld-ldflags=-all-static"
167 myconf="${myconf} --with-client-ldflags=-all-static"
168 myconf="${myconf} --disable-shared"
169 else
170 myconf="${myconf} --enable-shared --enable-static"
171 fi
172
173 if useq "debug" ; then
174 myconf="${myconf} --with-debug=full"
175 else
176 myconf="${myconf} --without-debug"
177 mysql_version_is_at_least "4.01.03.00" \
178 && useq "cluster" \
179 && myconf="${myconf} --without-ndb-debug"
180 fi
181
182 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
183 myconf="${myconf} --with-charset=utf8"
184 myconf="${myconf} --with-collation=utf8_general_ci"
185 else
186 myconf="${myconf} --with-charset=latin1"
187 myconf="${myconf} --with-collation=latin1_swedish_ci"
188 fi
189
190 if useq "embedded" ; then
191 myconf="${myconf} --with-embedded-privilege-control"
192 myconf="${myconf} --with-embedded-server"
193 else
194 myconf="${myconf} --without-embedded-privilege-control"
195 myconf="${myconf} --without-embedded-server"
196 fi
197
198}
199
200configure_40_41_50() {
201 myconf="${myconf} $(use_with perl bench)"
202 myconf="${myconf} --enable-assembler"
203 myconf="${myconf} --with-extra-tools"
204 myconf="${myconf} --with-innodb"
205 myconf="${myconf} --without-readline"
206 mysql_version_is_at_least "5.00.00.00" || myconf="${myconf} $(use_with raid)"
207
208 if useq "ssl" ; then
209 # --with-vio is not needed anymore, it's on by default and
210 # has been removed from configure
211 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio"
212 if mysql_version_is_at_least "5.00.06.00" ; then
213 # myconf="${myconf} --with-yassl"
214 myconf="${myconf} --with-openssl"
215 else
216 myconf="${myconf} --with-openssl"
217 fi
218 else
219 myconf="${myconf} --without-openssl"
220 fi
221
222 # The following fix is due to a bug with bdb on SPARC's. See:
223 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
224 # It comes down to non-64-bit safety problems.
225 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
226 ewarn "bdb berkeley-db disabled due to incompatible arch"
227 myconf="${myconf} --without-berkeley-db"
228 else
229 useq "berkdb" && myconf="${myconf} --with-berkeley-db=./bdb"
230 fi
231
232 if mysql_version_is_at_least "4.01.03.00" ; then
233 myconf="${myconf} --with-geometry"
234 myconf="${myconf} $(use_with cluster ndbcluster)"
235 fi
236
237 mysql_version_is_at_least "4.01.11.00" \
238 && myconf="${myconf} $(use_with big-tables)"
239
240 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
241 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
242 myconf="${myconf} --with-archive-storage-engine"
243
244 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
245 myconf="${myconf} --with-csv-storage-engine"
246
247 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
248 myconf="${myconf} --with-blackhole-storage-engine"
249
250 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
251 # http://dev.mysql.com/doc/mysql/en/federated-description.html
252 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
253 if mysql_version_is_at_least "5.00.03.00" ; then
254 einfo "Before using the Federated storage engine, please be sure to read"
255 einfo "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
256 myconf="${myconf} --with-federated-storage-engine"
257 fi
258 fi
259
260 mysql_version_is_at_least "5.00.18.00" \
261 && useq "max-idx-128" \
262 && myconf="${myconf} --with-max-indexes=128"
263}
264
265configure_51() {
266 # TODO : !!!!! readd --withouth-readline
267 # the failure depend upon config/ac-macros/readline.m4 checking into
268 # readline.h instead of history.h
269 myconf="${myconf} $(use_with big-tables)"
270 myconf="${myconf} $(use_with ssl)"
271 myconf="${myconf} --enable-assembler"
272 myconf="${myconf} --with-geometry"
273 myconf="${myconf} --with-readline"
274 myconf="${myconf} --with-row-based-replication"
275 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
276 myconf="${myconf} --without-pstack"
277 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128"
278
279 # 5.1 introduces a new way to manage storage engines (plugins)
280 # like configuration=none
281 local plugins="csv,myisam,myisammrg,heap"
282 if useq "extraengine" ; then
283 # like configuration=max-no-ndb, archive and example removed in 5.1.11
284 plugins="${plugins},blackhole,federated,ftexample,partition"
285
286 einfo "before to use federated engine be sure to read"
287 einfo "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
288 fi
289
290 if useq "innodb" ; then
291 plugins="${plugins},innobase"
292 fi
293
294 # like configuration=max-no-ndb
295 if useq "cluster" ; then
296 plugins="${plugins},ndbcluster"
297 myconf="${myconf} --with-ndb-binlog"
298 fi
299
300 myconf="${myconf} --with-plugins=${plugins}"
301}
302
303#
304# EBUILD FUNCTIONS
305#
306
99mysql_pkg_setup() { 307mysql_pkg_setup() {
100
101 enewgroup mysql 60 || die "problem adding group mysql" 308 enewgroup mysql 60 || die "problem adding 'mysql' group"
102 enewuser mysql 60 -1 /dev/null mysql \ 309 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
103 || die "problem adding user mysql" 310
311 if mysql_version_is_at_least "5.01.12.00" && useq "innodb" ; then
312 die "innodb now use cmake to build this is a TODO item"
313 fi
314
315 # Check for USE flag problems in pkg_setup
316 if useq "static" && useq "ssl" ; then
317 eerror "MySQL does not support being built statically with SSL support enabled!"
318 die "MySQL does not support being built statically with SSL support enabled!"
319 fi
320
321 if ! mysql_version_is_at_least "5.00.00.00" \
322 && useq "raid" \
323 && useq "static" ; then
324 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
325 eerror "with RAID support enabled."
326 die "USE flags 'raid' and 'static' conflict!"
327 fi
328
329 if mysql_version_is_at_least "4.01.03.00" \
330 && ( useq "cluster" || useq "extraengine" ) \
331 && useq "minimal" ; then
332 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
333 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
334 fi
335
336 useq "berkdb" && ewarn "Berkley DB support is deprecated and will be removed in future versions"
104} 337}
105 338
106mysql_src_unpack() { 339mysql_src_unpack() {
107 340 # Initialize the proper variables first
108 mysql_init_vars 341 mysql_init_vars
109 342
110 if useq static && useq ssl; then
111 local msg="MySQL does not support building statically with SSL support"
112 eerror "${msg}"
113 die "${msg}"
114 fi
115
116 if mysql_version_is_at_least "4.01.03.00" \
117 && useq cluster \
118 || useq extraengine \
119 && useq minimal ; then
120 die "USEs cluster, extraengine conflicts with \"minimal\""
121 fi
122
123 unpack ${A} || die 343 unpack ${A}
124 344
125 mv -f "${WORKDIR}/${NEWP}" "${S}" 345 mv -f "${WORKDIR}/${P/_/-}${MYSQL_RERELEASE}" "${S}"
126 cd "${S}" 346 cd "${S}"
127 347
128 EPATCH_SUFFIX="patch" 348 # Apply the patches for this MySQL version
129 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 349 if [[ -d "${WORKDIR}/${MY_FIXED_PV}" ]] ; then
130 mysql_mv_patches 350 EPATCH_SOURCE="${WORKDIR}/${MY_FIXED_PV}" EPATCH_SUFFIX="patch" epatch
131 epatch || die "failed to apply all patches" 351 fi
132 352
133 # additional check, remove bundled zlib 353 # Additional checks, remove bundled zlib
134 rm -f "${S}/zlib/"*.[ch] 354 rm -f "${S}/zlib/"*.[ch]
135 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 355 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
136 rm -f scripts/mysqlbug 356 rm -f "scripts/mysqlbug"
137 357
138 # Make charsets install in the right place 358 # Make charsets install in the right place
139 find . -name 'Makefile.am' \ 359 find . -name 'Makefile.am' \
140 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 360 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
141 361
143 mysql_version_is_at_least "5.00.15.00" \ 363 mysql_version_is_at_least "5.00.15.00" \
144 && sed -i -e "s!@GENTOO_EXT@!${MY_SUFFIX}!g" \ 364 && sed -i -e "s!@GENTOO_EXT@!${MY_SUFFIX}!g" \
145 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \ 365 -e "s!@GENTOO_SOCK_PATH@!var/run/mysqld!g" \
146 "${S}/server-tools/instance-manager/Makefile.am" 366 "${S}/server-tools/instance-manager/Makefile.am"
147 367
368 if mysql_version_is_at_least "4.01.00.00" ; then
148 # remove what need to be recreated, so we are sure it's actually done 369 # Remove what needs to be recreated, so we're sure it's actually done
149 find . -name Makefile -o -name Makefile.in -o -name configure -exec rm -f {} \; 370 find . -name Makefile \
371 -o -name Makefile.in \
372 -o -name configure \
373 -exec rm -f {} \;
150 rm ltmain.sh 374 rm -f "ltmain.sh"
375 rm -f "scripts/mysqlbug"
376 fi
151 377
152 local rebuilddirlist d buildstep bdbdir 378 local rebuilddirlist bdbdir d
153 379
154 if mysql_version_is_at_least "5.01.00.00" ; then 380 if mysql_version_is_at_least "5.01.00.00" ; then
155 rebuilddirlist=". storage/innobase" 381 rebuilddirlist=". storage/innobase"
156 bdbdir='storage/bdb/dist' 382 bdbdir='storage/bdb/dist'
157 else 383 else
158 rebuilddirlist=". innobase" 384 rebuilddirlist=". innobase"
159 bdbdir='bdb/dist' 385 bdbdir='bdb/dist'
160 fi 386 fi
161 387
162 for d in ${rebuilddirlist}; do 388 for d in ${rebuilddirlist} ; do
163 einfo "reconfiguring dir \"${d}\"" 389 einfo "Reconfiguring dir '${d}'"
164 pushd "${d}" &>/dev/null 390 pushd "${d}" &>/dev/null
165 AT_GNUCONF_UPDATE="yes" eautoreconf 391 AT_GNUCONF_UPDATE="yes" eautoreconf
166 popd &>/dev/null 392 popd &>/dev/null
167 done 393 done
168 394
169 #TODO berkdb in 5.1 need to be worked on 395 # TODO: berkdb in MySQL 5.1 needs to be worked on
396 if useq "berkdb" \
397 && ! mysql_check_version_range "4.00.00.00 to 4.00.99.99" \
170 if useq berkdb && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" 398 && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
171 then
172 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f ltmain.sh "${bdbdir}/ltmain.sh" 399 [[ -w "${bdbdir}/ltmain.sh" ]] && cp -f "ltmain.sh" "${bdbdir}/ltmain.sh"
173 pushd "${bdbdir}" && sh s_all || die "failed bdb reconfigure" &>/dev/null 400 pushd "${bdbdir}" \
401 && sh s_all \
402 || die "Failed bdb reconfigure" \
403 &>/dev/null
174 popd &>/dev/null 404 popd &>/dev/null
175 fi 405 fi
176
177} 406}
178 407
179mysql_src_compile() { 408mysql_src_compile() {
180 409 # Make sure the vars are correctly initialized
181 mysql_init_vars 410 mysql_init_vars
411
182 local myconf 412 local myconf
183 413
184 if useq static ; then 414 if useq "static" ; then
185 myconf="${myconf} --with-mysqld-ldflags=-all-static" 415 myconf="${myconf} --with-mysqld-ldflags=-all-static"
186 myconf="${myconf} --with-client-ldflags=-all-static" 416 myconf="${myconf} --with-client-ldflags=-all-static"
187 myconf="${myconf} --disable-shared" 417 myconf="${myconf} --disable-shared"
188 else 418 else
189 myconf="${myconf} --enable-shared --enable-static" 419 myconf="${myconf} --enable-shared --enable-static"
190 fi 420 fi
191 421
192 #myconf="${myconf} `use_with tcpd libwrap`"
193 myconf="${myconf} --without-libwrap" 422 myconf="${myconf} --without-libwrap"
194 423
195 if useq ssl ; then 424 if useq "ssl" ; then
196 # --with-vio is not needed anymore, it's on by default and 425 # --with-vio is not needed anymore, it's on by default and
197 # has been removed from configure 426 # has been removed from configure
198 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio" 427 mysql_version_is_at_least "5.00.04.00" || myconf="${myconf} --with-vio"
199 if mysql_version_is_at_least "5.00.06.00" ; then 428 if mysql_version_is_at_least "5.00.06.00" ; then
200 # yassl-0.96 is young break with gcc-4.0 || amd64 429 # yassl-0.96 is still young and breaks with GCC-4.X or amd64
201 #myconf="${myconf} --with-yassl" 430 # myconf="${myconf} --with-yassl"
202 myconf="${myconf} --with-openssl" 431 myconf="${myconf} --with-openssl"
203 else 432 else
204 myconf="${myconf} --with-openssl" 433 myconf="${myconf} --with-openssl"
205 fi 434 fi
206 else 435 else
207 myconf="${myconf} --without-openssl" 436 myconf="${myconf} --without-openssl"
208 fi 437 fi
209 438
210 if useq debug; then 439 if useq "debug" ; then
211 myconf="${myconf} --with-debug=full" 440 myconf="${myconf} --with-debug=full"
212 else 441 else
213 myconf="${myconf} --without-debug" 442 myconf="${myconf} --without-debug"
214 mysql_version_is_at_least "4.01.03.00" && useq cluster && myconf="${myconf} --without-ndb-debug"
215 fi
216 443
217 # benchmarking stuff needs perl 444 mysql_version_is_at_least "4.01.03.00" && useq "cluster" \
218 # and shouldn't be bothered with on minimal builds
219 if useq perl && ! useq minimal; then
220 myconf="${myconf} --with-bench"
221 else
222 myconf="${myconf} --without-bench" 445 && myconf="${myconf} --without-ndb-debug"
223 fi 446 fi
224 447
225 # these are things we exclude from a minimal build 448 # These are things we exclude from a minimal build.
226 # note that the server actually does get built and installed 449 # Note that the server actually does get built and installed,
227 # but we then delete it before packaging. 450 # but we then delete it.
228 local minimal_exclude_list="server embedded-server extra-tools innodb" 451 local minimal_exclude_list="server embedded-server extra-tools innodb bench"
452
229 if ! useq minimal; then 453 if ! useq "minimal" ; then
230 for i in ${minimal_exclude_list}; do 454 myconf="${myconf} --with-server"
455 myconf="${myconf} --with-extra-tools"
456
457 if ! mysql_version_is_at_least "5.00.00.00" ; then
458 if useq "raid" ; then
231 myconf="${myconf} --with-${i}" 459 myconf="${myconf} --with-raid"
232 done 460 else
233
234 if useq static ; then
235 myconf="${myconf} --without-raid" 461 myconf="${myconf} --without-raid"
236 ewarn "disabling raid support, has problem with static" 462 fi
463 fi
464
465 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then
466 myconf="${myconf} --with-charset=utf8"
467 myconf="${myconf} --with-collation=utf8_general_ci"
237 else 468 else
469 myconf="${myconf} --with-charset=latin1"
470 myconf="${myconf} --with-collation=latin1_swedish_ci"
471 fi
472
473 # Optional again with MySQL 5.1
238 if mysql_version_is_at_least "5.00.00.00" ; then 474 if mysql_version_is_at_least "5.01.00.00" ; then
475 if useq "innodb" ; then
239 myconf="${myconf} --without-raid" 476 myconf="${myconf} --with-innodb"
240 else 477 else
241 myconf="${myconf} `use_with raid`" 478 myconf="${myconf} --without-innodb"
242 fi 479 fi
243 fi 480 fi
244 481
245 if ! mysql_version_is_at_least "5.00.00.00" ; then
246 if mysql_version_is_at_least "4.01.00.00" ; then
247 myconf="${myconf} --with-charset=utf8"
248 myconf="${myconf} --with-collation=utf8_general_ci"
249 else
250 myconf="${myconf} --with-charset=latin1"
251 myconf="${myconf} --with-collation=latin1_swedish_ci"
252 fi
253 fi
254
255 # optional again from 2005-12-05
256 if mysql_version_is_at_least "5.01.00.00" ; then
257 myconf="${myconf} $(use_with innodb)"
258 else
259 myconf="${myconf} --with-innodb"
260 fi
261
262 # lots of chars 482 # Lots of charsets
263 myconf="${myconf} --with-extra-charsets=all" 483 myconf="${myconf} --with-extra-charsets=all"
264 484
265 #The following fix is due to a bug with bdb on sparc's. See: 485 # The following fix is due to a bug with bdb on SPARC's. See:
266 #http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8 486 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
267 # it comes down to non-64-bit safety problems 487 # It comes down to non-64-bit safety problems.
268 if useq sparc || useq alpha || useq hppa || useq mips || useq amd64 \ 488 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
269 || mysql_check_version_range "5.01.00.00 to 5.01.06.99"
270 then
271 ewarn "bdb berkeley-db disabled due to arch or version" 489 ewarn "bdb berkeley-db disabled due to incompatible arch"
272 myconf="${myconf} --without-berkeley-db" 490 myconf="${myconf} --without-berkeley-db"
273 else 491 else
274 #TODO berkdb in 5.1 need to be worked on 492 # TODO: berkdb in MySQL 5.1 needs to be worked on
275 useq berkdb && \
276 ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" \ 493 if useq "berkdb" && ! mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
277 && myconf="${myconf} --with-berkeley-db=./bdb" \ 494 myconf="${myconf} --with-berkeley-db=./bdb"
495 else
278 || myconf="${myconf} --without-berkeley-db" 496 myconf="${myconf} --without-berkeley-db"
497 fi
279 fi 498 fi
280 499
281 if mysql_version_is_at_least "4.01.03.00" ; then 500 if mysql_version_is_at_least "4.01.03.00" ; then
282 #myconf="${myconf} $(use_with geometry)"
283 myconf="${myconf} --with-geometry" 501 myconf="${myconf} --with-geometry"
502
503 if useq "cluster" ; then
504 myconf="${myconf} --with-ndbcluster"
505 else
284 myconf="${myconf} $(use_with cluster ndbcluster)" 506 myconf="${myconf} --without-ndbcluster"
285 fi 507 fi
508 fi
286 509
287 mysql_version_is_at_least "4.01.11.00" && myconf="${myconf} `use_with big-tables`" 510 if useq "big-tables" ; then
511 myconf="${myconf} --with-big-tables"
512 else
513 myconf="${myconf} --without-big-tables"
514 fi
288 515
289 mysql_version_is_at_least "5.01.06.00" && myconf="${myconf} --with-ndb-binlog" 516 mysql_version_is_at_least "5.01.06.00" \
517 && myconf="${myconf} --with-ndb-binlog"
290 518
291 if useq embedded ; then 519 if useq "embedded" ; then
292 #REMIND, need the privilege control enabled ?
293 myconf="${myconf} --without-embedded-privilege-control" 520 myconf="${myconf} --with-embedded-privilege-control"
294 myconf="${myconf} --with-embedded-server" 521 myconf="${myconf} --with-embedded-server"
295 else 522 else
296 myconf="${myconf} --without-embedded-privilege-control" 523 myconf="${myconf} --without-embedded-privilege-control"
297 myconf="${myconf} --without-embedded-server" 524 myconf="${myconf} --without-embedded-server"
298 fi 525 fi
526
527 # Benchmarking stuff needs Perl
528 if useq "perl" ; then
529 myconf="${myconf} --with-bench"
299 else 530 else
531 myconf="${myconf} --without-bench"
532 fi
533 else
300 for i in ${minimal_exclude_list}; do 534 for i in ${minimal_exclude_list} ; do
301 myconf="${myconf} --without-${i}" 535 myconf="${myconf} --without-${i}"
302 done 536 done
303 myconf="${myconf} --without-berkeley-db" 537 myconf="${myconf} --without-berkeley-db"
304 myconf="${myconf} --with-extra-charsets=none" 538 myconf="${myconf} --with-extra-charsets=none"
305 fi 539 fi
306 540
307 if mysql_version_is_at_least "4.01.03.00" && useq extraengine; then 541 if mysql_version_is_at_least "4.01.03.00" && useq "extraengine" ; then
308 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 542 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
309 myconf="${myconf} --with-archive-storage-engine" 543 myconf="${myconf} --with-archive-storage-engine"
544
310 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 545 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
311
312 mysql_version_is_at_least "4.01.04.00" \
313 && myconf="${myconf} --with-csv-storage-engine" 546 myconf="${myconf} --with-csv-storage-engine"
314 547
315 mysql_version_is_at_least "4.01.11.00" \ 548 # http://dev.mysql.com/doc/mysql/en/blackhole-storage-engine.html
316 && myconf="${myconf} --with-blackhole-storage-engine" 549 myconf="${myconf} --with-blackhole-storage-engine"
317 550
551 # http://dev.mysql.com/doc/mysql/en/federated-storage-engine.html
318 # http://dev.mysql.com/doc/mysql/en/federated-description.html 552 # http://dev.mysql.com/doc/mysql/en/federated-description.html
319 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html 553 # http://dev.mysql.com/doc/mysql/en/federated-limitations.html
320 if mysql_version_is_at_least "5.00.03.00" ; then 554 if mysql_version_is_at_least "5.00.03.00" ; then
321 einfo "before to use federated engine be sure to read" 555 einfo "Before using the Federated storage engine, please be sure to read"
322 einfo "http://dev.mysql.com/doc/refman/5.0/en/federated-limitations.html" 556 einfo "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
323 myconf="${myconf} --with-federated-storage-engine" 557 myconf="${myconf} --with-federated-storage-engine"
558 fi
324 559
325 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html 560 # http://dev.mysql.com/doc/refman/5.1/en/partitioning-overview.html
326 if mysql_version_is_at_least "5.01.00.00" ; then 561 if mysql_version_is_at_least "5.01.00.00" ; then
327 myconf="${myconf} --with-partition" 562 myconf="${myconf} --with-partition"
328 fi 563 fi
329 fi
330
331 fi 564 fi
332 565
333 mysql_version_is_at_least "5.00.18.00" \ 566 mysql_version_is_at_least "5.00.18.00" \
334 && useq "max-idx-128" \ 567 && useq "max-idx-128" \
335 && myconf="${myconf} --with-max-indexes=128" 568 && myconf="${myconf} --with-max-indexes=128"
336 569
337 if mysql_version_is_at_least "5.01.05.00" ; then 570 mysql_version_is_at_least "5.01.05.00" \
338 myconf="${myconf} --with-row-based-replication" 571 && myconf="${myconf} --with-row-based-replication"
339 fi
340 572
341 #TODO rechek again later, had problem with assembler enabled 573 # TODO: Rechek again later, there were problems with assembler enabled
342 # and some combination of use-flags with 5.1 574 # and some combination of USE flags with MySQL 5.1
343 if mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then 575 if mysql_check_version_range "5.01.00.00 to 5.01.08.99" ; then
344 myconf="${myconf} --disable-assembler" 576 myconf="${myconf} --disable-assembler"
345 else 577 else
346 myconf="${myconf} --enable-assembler" 578 myconf="${myconf} --enable-assembler"
347 fi 579 fi
348 580
349 #Bug #114895,Bug #110149 581 # Bug #114895, bug #110149
350 filter-flags "-O" "-O[01]" 582 filter-flags "-O" "-O[01]"
583
351 #glibc-2.3.2_pre fix; bug #16496 584 # glib-2.3.2_pre fix, bug #16496
352 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 585 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
353 586
354 #the compiler flags are as per their "official" spec ;) 587 append-flags "-fno-exceptions -fno-strict-aliasing"
355 #CFLAGS="${CFLAGS/-O?/} -O3" \
356 export CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-exceptions -fno-rtti" 588 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
357 mysql_version_is_at_least "5.00.00.00" \ 589 mysql_version_is_at_least "5.00.00.00" \
358 && export CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 590 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
591 export CXXFLAGS="${CXXFLAGS}"
359 592
360 econf \ 593 econf \
361 --program-suffix="${MY_SUFFIX}" \
362 --libexecdir="/usr/sbin" \ 594 --libexecdir="/usr/sbin" \
363 --sysconfdir="${MY_SYSCONFDIR}" \ 595 --sysconfdir="${MY_SYSCONFDIR}" \
364 --localstatedir="${MY_LOCALSTATEDIR}" \ 596 --localstatedir="${MY_LOCALSTATEDIR}" \
365 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 597 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
366 --libdir="${MY_LIBDIR}" \ 598 --libdir="${MY_LIBDIR}" \
370 --with-mysqld-user=mysql \ 602 --with-mysqld-user=mysql \
371 --with-client-ldflags=-lstdc++ \ 603 --with-client-ldflags=-lstdc++ \
372 --enable-thread-safe-client \ 604 --enable-thread-safe-client \
373 --with-comment="Gentoo Linux ${PF}" \ 605 --with-comment="Gentoo Linux ${PF}" \
374 --with-unix-socket-path="/var/run/mysqld/mysqld.sock" \ 606 --with-unix-socket-path="/var/run/mysqld/mysqld.sock" \
375 --with-lib-ccflags="-fPIC" \
376 --without-readline \ 607 --without-readline \
377 --without-docs \ 608 --without-docs \
378 ${myconf} || die "bad ./configure" 609 ${myconf} || die "bad ./configure"
379 610
380 # TODO Move this before autoreconf !!! 611 # TODO: Move this before autoreconf !!!
381 find . -type f -name Makefile -print0 \ 612 find . -type f -name Makefile -print0 \
382 | xargs -0 -n100 sed -i \ 613 | xargs -0 -n100 sed -i \
383 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 614 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
384 615
385 emake || die "compile problem" 616 emake || die "compile problem"
386} 617}
387 618
388mysql_src_install() { 619mysql_src_install() {
389 620 # Make sure the vars are correctly initialized
390 mysql_init_vars 621 mysql_init_vars
622
391 make install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 623 make install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "make install error"
392 624
393 insinto "${MY_INCLUDEDIR}" 625 insinto "${MY_INCLUDEDIR}"
394 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 626 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
395 627
396 # convenience links 628 # Convenience links
397 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 629 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
398 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 630 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
399 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 631 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
400 632
401 # various junk (my-*.cnf moved elsewhere) 633 # Various junk (my-*.cnf moved elsewhere)
402 rm -rf "${D}/usr/share/info" 634 rm -Rf "${D}/usr/share/info"
403 for removeme in "mysql-log-rotate" mysql.server* \ 635 for removeme in "mysql-log-rotate" mysql.server* \
404 binary-configure* my-*.cnf mi_test_all* 636 binary-configure* my-*.cnf mi_test_all*
405 do 637 do
406 rm -f ${D}/usr/share/mysql/${removeme} 638 rm -f "${D}"/usr/share/mysql/${removeme}
407 done 639 done
408 640
409 # TODO change at Makefile-am level
410 for moveme in "mysql_fix_privilege_tables.sql" \
411 "fill_help_tables.sql" "ndb-config-2-node.ini"
412 do
413 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
414 done
415
416 if [[ -n "${MY_SUFFIX}" ]] ; then
417 local notcatched=$(ls "${D}/usr/share/mysql"/*)
418 if [[ -n "${notcatched}" ]] ; then
419 ewarn "QA notice"
420 ewarn "${notcatched} files in /usr/share/mysql"
421 ewarn "bug mysql-herd to manage them"
422 fi
423 rm -rf "${D}/usr/share/mysql"
424 fi
425
426 # clean up stuff for a minimal build 641 # Clean up stuff for a minimal build
427 # this is anything server-specific
428 if useq minimal; then 642 if useq "minimal" ; then
429 rm -rf ${D}${MY_SHAREDSTATEDIR}/{mysql-test,sql-bench} 643 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
430 rm -f ${D}/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 644 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
431 rm -f "${D}/usr/sbin/mysqld${MY_SUFFIX}" 645 rm -f "${D}/usr/sbin/mysqld"
432 rm -f ${D}${MY_LIBDIR}/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 646 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
433 fi 647 fi
434 648
435 # config stuff 649 # Configuration stuff
650 if mysql_version_is_at_least "4.01.00.00" ; then
651 mysql_mycnf_version="4.1"
652 else
653 mysql_mycnf_version="4.0"
654 fi
436 insinto "${MY_SYSCONFDIR}" 655 insinto "${MY_SYSCONFDIR}"
437 doins scripts/mysqlaccess.conf 656 doins "scripts/mysqlaccess.conf"
438 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
439 -e "s!@DATADIR@!${DATADIR}!g" \ 657 sed -e "s!@DATADIR@!${DATADIR}!g" \
440 "${FILESDIR}/my.cnf-4.1-r1" \ 658 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
441 > "${TMPDIR}/my.cnf.ok" 659 > "${TMPDIR}/my.cnf.ok"
660 if mysql_version_is_at_least "4.01.00.00" && useq "latin1" ; then
661 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
662 fi
442 newins "${TMPDIR}/my.cnf.ok" my.cnf 663 newins "${TMPDIR}/my.cnf.ok" my.cnf
443 664
444 insinto "/etc/conf.d" 665 insinto "/etc/conf.d"
445 newins "${FILESDIR}/mysql-slot.conf.d-r1" "mysql" 666 newins "${FILESDIR}/mysql.conf.d" "mysql"
446 mysql_version_is_at_least "5.00.11.00" \ 667 mysql_version_is_at_least "5.00.11.00" \
447 && newins "${FILESDIR}/mysqlmanager-slot.conf.d" "mysqlmanager" 668 && newins "${FILESDIR}/mysqlmanager.conf.d" "mysqlmanager"
448 669
449 # minimal builds don't have the server 670 # Minimal builds don't have the MySQL server
450 if ! useq minimal; then 671 if ! useq "minimal" ; then
451 exeinto /etc/init.d 672 exeinto "/etc/init.d"
452 newexe "${FILESDIR}/mysql-slot.rc6-r3" "mysql" 673 newexe "${FILESDIR}/mysql.rc6" "mysql"
453
454 mysql_version_is_at_least "5.00.11.00" \ 674 mysql_version_is_at_least "5.00.11.00" \
455 && newexe "${FILESDIR}/mysqlmanager-slot.rc6" "mysqlmanager" 675 && newexe "${FILESDIR}/mysqlmanager.rc6" "mysqlmanager"
676
456 insinto /etc/logrotate.d 677 insinto "/etc/logrotate.d"
457 sed -e "s!___MY_SUFFIX___!${MY_SUFFIX}!g" \
458 "${FILESDIR}/logrotate-slot.mysql" \
459 > "${TMPDIR}/logrotate.mysql"
460 newins "${TMPDIR}/logrotate.mysql" "mysql${MY_SUFFIX}" 678 newins "${FILESDIR}/logrotate.mysql" "mysql"
461 679
462 #empty dirs... 680 # Empty directories ...
463 diropts "-m0750" 681 diropts "-m0750"
464 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 682 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
465 dodir "${DATADIR}" 683 dodir "${DATADIR}"
466 keepdir "${DATADIR}" 684 keepdir "${DATADIR}"
467 chown -R mysql:mysql "${D}/${DATADIR}" 685 chown -R mysql:mysql "${D}/${DATADIR}"
473 keepdir "${folder}" 691 keepdir "${folder}"
474 chown -R mysql:mysql "${D}/${folder}" 692 chown -R mysql:mysql "${D}/${folder}"
475 done 693 done
476 fi 694 fi
477 695
478 # docs 696 # Docs
479 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 697 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
698
480 # minimal builds don't have the server 699 # Minimal builds don't have the MySQL server
481 if ! useq minimal; then 700 if ! useq "minimal" ; then
482 docinto "support-files" 701 docinto "support-files"
483 for script in \ 702 for script in \
484 support-files/my-*.cnf \ 703 support-files/my-*.cnf \
485 support-files/magic \ 704 support-files/magic \
486 support-files/ndb-config-2-node.ini 705 support-files/ndb-config-2-node.ini
492 for script in scripts/mysql* ; do 711 for script in scripts/mysql* ; do
493 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 712 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
494 done 713 done
495 fi 714 fi
496 715
497 # oops, temporary fix 716 ROOT="${D}" mysql_lib_symlinks
498 mysql_check_version_range "5.00.16.00 to 5.00.18.99" \
499 && cp -f \
500 "${WORKDIR}/mysql-extras/fill_help_tables.sql-5.0" \
501 "${D}/usr/share/mysql${MY_SUFFIX}/fill_help_tables.sql"
502
503 if [[ ${SLOT} -gt 0 ]] ; then
504 # MOVED HERE DUE TO BUG #121445
505 # create a list of files, to be used
506 # by external utilities
507 mkdir -p "${D}/var/lib/eselect/mysql/"
508 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
509 pushd "${D}/" &>/dev/null
510 find usr/bin/ usr/sbin/ \
511 -type f -name "*${MY_SUFFIX}*" \
512 -and -not -name "mysql_config${MY_SUFFIX}" \
513 > "${filelist}"
514 find usr/share/man \
515 -type f -name "*${MY_SUFFIX}*" \
516 | sed -e 's/$/.gz/' \
517 >> "${filelist}"
518 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
519 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
520 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
521 popd &>/dev/null
522 fi
523} 717}
524 718
525mysql_pkg_preinst() { 719mysql_pkg_preinst() {
526
527 enewgroup mysql 60 || die "problem adding group mysql" 720 enewgroup mysql 60 || die "problem adding 'mysql' group"
528 enewuser mysql 60 -1 /dev/null mysql \ 721 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
529 || die "problem adding user mysql"
530} 722}
531 723
532mysql_pkg_postinst() { 724mysql_pkg_postinst() {
533 725 # Make sure the vars are correctly initialized
534 mysql_init_vars 726 mysql_init_vars
535 mysql_lib_symlinks
536 727
537 # mind at FEATURES=collision-protect before to remove this 728 # Check FEATURES="collision-protect" before removing this
538 [ -d "${ROOT}/var/log/mysql" ] \ 729 [[ -d "${ROOT}/var/log/mysql" ]] \
539 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}" 730 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
540 731
541 #secure the logfiles... does this bother anybody? 732 # Secure the logfiles
542 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err} 733 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
543 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql* 734 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
544 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql* 735 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
545 736
546 if ! useq minimal; then 737 if ! useq "minimal" ; then
547 if [[ ${SLOT} -gt 0 ]] ; then
548 einfo "you may want to read:"
549 einfo "http://www.gentoo.org/doc/en/mysql-upgrade-slotted.xml"
550 einfo "you may want to run \"eselect mysql list\" followed by a "
551 einfo "\"eselect mysql set 1\" to choose the default mysql server"
552 fi
553
554 # your friendly public service announcement... 738 # Your friendly public service announcement ...
555 einfo 739 einfo
556 einfo "You might want to run:" 740 einfo "You might want to run:"
557 einfo "\"emerge --config =${CATEGORY}/${PF}\"" 741 einfo "\"emerge --config =${CATEGORY}/${PF}\""
558 einfo "if this is a new install." 742 einfo "if this is a new install."
559 einfo 743 einfo
560 mysql_version_is_at_least "5.01.00.00" \ 744 mysql_version_is_at_least "5.01.00.00" \
561 || einfo "InnoDB is not optional as of MySQL-4.0.24, at the request of upstream." 745 || einfo "InnoDB is *not* optional as of MySQL-4.0.24, at the request of upstream."
562 fi 746 fi
747 useq "berkdb" && ewarn "Berkley DB support is deprecated and will be removed in future versions"
563} 748}
564 749
565mysql_pkg_config() { 750mysql_pkg_config() {
751 # Make sure the vars are correctly initialized
566 mysql_init_vars 752 mysql_init_vars
753
567 [[ -z "${DATADIR}" ]] && die "sorry, unable to find DATADIR" 754 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR"
568 755
569 if built_with_use dev-db/mysql minimal; then 756 if built_with_use dev-db/mysql minimal ; then
570 die "Minimal builds do NOT include the MySQL server" 757 die "Minimal builds do NOT include the MySQL server"
571 fi 758 fi
572 759
573 local pwd1="a" 760 local pwd1="a"
574 local pwd2="b" 761 local pwd2="b"
580 ewarn "Please rename or delete it if you wish to replace it." 767 ewarn "Please rename or delete it if you wish to replace it."
581 die "MySQL database already exists!" 768 die "MySQL database already exists!"
582 fi 769 fi
583 770
584 einfo "Creating the mysql database and setting proper" 771 einfo "Creating the mysql database and setting proper"
585 einfo "permissions on it..." 772 einfo "permissions on it ..."
586 773
587 einfo "Insert a password for the mysql 'root' user" 774 einfo "Insert a password for the mysql 'root' user"
588 ewarn "Avoid [\"'\\_%] characters in the password" 775 ewarn "Avoid [\"'\\_%] characters in the password"
589
590 read -rsp " >" pwd1 ; echo 776 read -rsp " >" pwd1 ; echo
777
591 einfo "Check the password" 778 einfo "Retype the password"
592 read -rsp " >" pwd2 ; echo 779 read -rsp " >" pwd2 ; echo
593 780
594 if [[ "x$pwd1" != "x$pwd2" ]] ; then 781 if [[ "x$pwd1" != "x$pwd2" ]] ; then
595 die "Passwords are not the same" 782 die "Passwords are not the same"
596 fi 783 fi
597 784
598 local options="" 785 local options=""
599 local sqltmp="$(emktemp)" 786 local sqltmp="$(emktemp)"
600 787
601 local help_tables="${MY_SHAREDSTATEDIR}/fill_help_tables.sql" 788 local help_tables="${ROOT}${MY_SHAREDSTATEDIR}/fill_help_tables.sql"
602 [[ -r "${help_tables}" ]] \ 789 [[ -r "${help_tables}" ]] \
603 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 790 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
604 || touch "${TMPDIR}/fill_help_tables.sql" 791 || touch "${TMPDIR}/fill_help_tables.sql"
605 help_tables="${TMPDIR}/fill_help_tables.sql" 792 help_tables="${TMPDIR}/fill_help_tables.sql"
606 793
607 pushd "${TMPDIR}" &>/dev/null 794 pushd "${TMPDIR}" &>/dev/null
608 ${ROOT}/usr/bin/mysql_install_db${MY_SUFFIX} | grep -B5 -A999 -i "ERROR" 795 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR"
609 popd &>/dev/null 796 popd &>/dev/null
610 [[ -f ${ROOT}/${DATADIR}/mysql/user.frm ]] || die "MySQL databases not installed" 797 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \
798 || die "MySQL databases not installed"
611 chown -R mysql:mysql ${ROOT}/${DATADIR} 2> /dev/null 799 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null
612 chmod 0750 ${ROOT}/${DATADIR} 2> /dev/null 800 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null
613 801
614 if mysql_version_is_at_least "4.01.03.00" ; then 802 if mysql_version_is_at_least "4.01.03.00" ; then
615 options="--skip-ndbcluster" 803 options="--skip-ndbcluster"
616 804
617 # Filling timezones, see 805 # Filling timezones, see
618 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 806 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
619 ${ROOT}/usr/bin/mysql_tzinfo_to_sql${MY_SUFFIX} ${ROOT}/usr/share/zoneinfo \ 807 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
620 > "${sqltmp}" 2>/dev/null
621 808
622 if [[ -r "${help_tables}" ]] ; then 809 if [[ -r "${help_tables}" ]] ; then
623 cat "${help_tables}" >> "${sqltmp}" 810 cat "${help_tables}" >> "${sqltmp}"
624 fi 811 fi
625 fi 812 fi
626 813
627 local socket=${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock 814 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
628 local pidfile=${ROOT}/var/run/mysqld/mysqld${MY_SUFFIX}${RANDOM}.pid 815 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
629 local mysqld="${ROOT}/usr/sbin/mysqld${MY_SUFFIX} \ 816 local mysqld="${ROOT}/usr/sbin/mysqld \
630 ${options} \ 817 ${options} \
631 --user=mysql \ 818 --user=mysql \
632 --skip-grant-tables \ 819 --skip-grant-tables \
633 --basedir=${ROOT}/usr \ 820 --basedir=${ROOT}/usr \
634 --datadir=${ROOT}/${DATADIR} \ 821 --datadir=${ROOT}/${DATADIR} \
637 --skip-networking \ 824 --skip-networking \
638 --max_allowed_packet=8M \ 825 --max_allowed_packet=8M \
639 --net_buffer_length=16K \ 826 --net_buffer_length=16K \
640 --socket=${socket} \ 827 --socket=${socket} \
641 --pid-file=${pidfile}" 828 --pid-file=${pidfile}"
642 $mysqld & 829 ${mysqld} &
643 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 830 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
644 maxtry=$(($maxtry-1)) 831 maxtry=$((${maxtry}-1))
645 echo -n "." 832 echo -n "."
646 sleep 1 833 sleep 1
647 done 834 done
648 835
649 # do this from memory we don't want clear text password in temp files 836 # Do this from memory, as we don't want clear text passwords in temp files
650 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 837 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'"
651 ${ROOT}/usr/bin/mysql${MY_SUFFIX} \ 838 "${ROOT}/usr/bin/mysql" \
652 --socket=${socket} \ 839 --socket=${socket} \
653 -hlocalhost \ 840 -hlocalhost \
654 -e "${sql}" 841 -e "${sql}"
655 842
656 einfo "Loading \"zoneinfo\" this step may require few seconds" 843 einfo "Loading \"zoneinfo\", this step may require a few seconds ..."
657 844
658 ${ROOT}/usr/bin/mysql${MY_SUFFIX} \ 845 "${ROOT}/usr/bin/mysql" \
659 --socket=${socket} \ 846 --socket=${socket} \
660 -hlocalhost \ 847 -hlocalhost \
661 -uroot \ 848 -uroot \
662 -p"${pwd1}" \ 849 -p"${pwd1}" \
663 mysql < "${sqltmp}" 850 mysql < "${sqltmp}"
664 851
665 # server stop and cleanup 852 # Stop the server and cleanup
666 kill $(< "${pidfile}" ) 853 kill $(< "${pidfile}" )
667 rm "${sqltmp}" 854 rm -f "${sqltmp}"
668 einfo "stopping the server," 855 einfo "Stopping the server ..."
669 wait %1 856 wait %1
670 einfo "done" 857 einfo "Done"
671}
672
673mysql_pkg_prerm() {
674 if [[ ${SLOT} -gt 0 ]] ; then
675 # external program
676 eselect mysql slot_remove "${SLOT}"
677 fi
678} 858}
679 859
680mysql_pkg_postrm() { 860mysql_pkg_postrm() {
681 mysql_lib_symlinks 861 mysql_lib_symlinks
682 if [[ ${SLOT} -gt 0 ]] ; then
683 einfo "you may want to run \"eselect mysql list\" followed by a "
684 einfo "\"eselect mysql list\" to choose the default mysql server"
685 fi
686} 862}

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.38

  ViewVC Help
Powered by ViewVC 1.1.20